# Simple Plugin

This plugin shows how to register a simple class with the name
MyClass. The class contains two preperties (one scalar and one
staticly sized array). Both properties have accessors, although, these
can be omitted if no logic should be associated with the property
accesess.

## Building

The plugin can be built with the Makefile, just type make, but take
into account that if you have installed T-EMU in a non-standard
location, then the paths in the makefile need to be adapted.

## Running

Start the temu command line interface and load the plugin as follows:

  t-emu> import Simple

You can list the classes in the system as follows:

  t-emu> class-list

Then create an object:

  t-emu> object-create class=MyClass name=myObject args=hello:1,bar:2

You can list he existing objects:

  t-emu> object-list

You can show the contents of an object with:

  t-emu> object-info obj=myObject

You can modify a property as follows:

  t-emu> object-prop-write prop=myObject.myArray index=1 val=42
